
/*
Copyright 2007-2009 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function YaripContentBlacklistDialog()
{

    this.regexpTextbox = null;
    this.pageMenulist = null;
    this.location = null;
    this.content = null;
    this.obj = null;
    this.regExp = null;

    this.setRegExp = function(value)
    {
        if (!this.obj) return;
        this.regExp = value;
    }

    this.load = function()
    {
        if (!"arguments" in window || window.arguments.length < 1) return;

        this.obj = window.arguments[0];
        if (!this.obj) return;

        this.stringbundle = document.getElementById("contentBlacklist-dialog-stringbundle");
        this.pageMenulist = document.getElementById("page");
        this.regexpTextbox = document.getElementById("regexp");

        this.pageMenulist.value = this.obj.pageAddress;
        this.setRegExp(this.obj.content.getRegExp());
        this.regexpTextbox.value = this.regExp;
        this.regexpTextbox.focus();
        this.regexpTextbox.select();

        this.location = this.obj.itemLocation;
        this.content = this.obj.itemContent;
        if (!this.location || !this.content) {
            this.pageMenulist.disabled = true;
            return;
        }

        var menupopup = document.getElementById("page-menupopup");
        var menuitem = null;
        var address = yarip.getAddress(this.location, yarip.PAGE_MODE);
        if (address)
        {
            menuitem = document.createElement("menuitem");
            menuitem.setAttribute("label", address);
            menuitem.setAttribute("value", address);
            menupopup.appendChild(menuitem);
        }
        address = yarip.getAddress(this.location, yarip.FIRSTDIR_MODE);
        if (address)
        {
            menuitem = document.createElement("menuitem");
            menuitem.setAttribute("label", address);
            menuitem.setAttribute("value", address);
            menupopup.appendChild(menuitem);
        }
        address = yarip.getAddress(this.location, yarip.FQDN_MODE);
        if (address)
        {
            menuitem = document.createElement("menuitem");
            menuitem.setAttribute("label", address);
            menuitem.setAttribute("value", address);
            menupopup.appendChild(menuitem);
        }
        address = yarip.getAddress(this.location, yarip.SLD_MODE);
        if (address)
        {
            menuitem = document.createElement("menuitem");
            menuitem.setAttribute("label", address);
            menuitem.setAttribute("value", address);
            menupopup.appendChild(menuitem);
        }

        address = yarip.getAddress(this.content, yarip.PAGE_MODE);
        if (address)
        {
            menuitem = document.createElement("menuitem");
            menuitem.setAttribute("label", address);
            menuitem.setAttribute("value", address);
            menupopup.appendChild(menuitem);
        }
        address = yarip.getAddress(this.content, yarip.FIRSTDIR_MODE);
        if (address)
        {
            menuitem = document.createElement("menuitem");
            menuitem.setAttribute("label", address);
            menuitem.setAttribute("value", address);
            menupopup.appendChild(menuitem);
        }
        address = yarip.getAddress(this.content, yarip.FQDN_MODE);
        if (address)
        {
            menuitem = document.createElement("menuitem");
            menuitem.setAttribute("label", address);
            menuitem.setAttribute("value", address);
            menupopup.appendChild(menuitem);
        }
        address = yarip.getAddress(this.content, yarip.SLD_MODE);
        if (address)
        {
            menuitem = document.createElement("menuitem");
            menuitem.setAttribute("label", address);
            menuitem.setAttribute("value", address);
            menupopup.appendChild(menuitem);
        }
    }

    this.accept = function()
    {
        if (!this.obj) return;

        if (yarip.checkRegExp(this.regExp)) {
            this.obj.content.setRegExp(this.regExp);
            this.obj.pageAddress = this.pageMenulist.value;

            var fh = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory2);
            fh.addEntry("regexp", this.regExp);
        } else {
            var msg = this.stringbundle.getString("ERR_INVALID_REGEXP");
            alert(msg);
            throw new YaripException(msg);
        }
    }

    this.cancel = function()
    {
        if (this.obj) this.obj.content = null;
    }
}
