
/*
Copyright 2007-2009 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function YaripPageDialog()
{
    this.stringbundle = null;
    this.listboxPages = null;
    this.listitemDummy = null;
    this.dialogheaderPage = null;
    this.tabbox = null;

    this.tab = null;
    this.tabs = null;
    this.userSelect = false;

    this.listboxPages = null;

    this.page = null;

    this.OFFICIAL_SCHEME = "(aaas|aaa|acap|afs|cap|cid|crid|data|dav|dict|dns|dtn|fax|file|ftp|gopher|go|h323|https|http|iax2|icap|imap|im|info|ipp|iris\\.beep|iris\\.lwz|iris\\.xpcs|iris\\.xpc|iris|ldap|mailserver|mailto|mid|modem|msrps|msrp|mtqp|mupdate|news|nfs|nntp|opaquelocktoken|pack|pop|pres|prospero|rtsp|service|shttp|sips|sip|snmp|soap\\.beeps|soap\\.beep|tag|telnet|tel|tftp|thismessage|tip|tn3270|tv|urn|vemmi|wais|xmlrpc\\.beeps|xmlrpc\\.beep|xmpp|z39\\.50r|z39\\.50s)";
    this.UNOFFICIAL_SCHEME = "(about|addbook|afp|aim|applescript|bcp|bk|btspp|callto|castanet|cdv|chrome|chttp|cvs|daytime|device|doi|ed2k|eid|enp|feed|finger|fish|freenet|gg|gizmoproject|gsiftp|gsm-sms|h324|hdl|hnews|httpsy|iioploc|ilu|IOR|ircs|irc|itms|jar|javascript|jdbc|klik|kn|lastfm|ldaps|lifn|livescript|lrq|magnet|mailbox|man|md5|mms|mocha|moz-abmdbdirectory|msnim|myim|notes|nsfw|oai|pcast|phone|php|pop3|printer|psyc|pyimp|rdar|res|rsync|rvp|rwhois|rx|sdp|secondlife|sftp|skype|smb|sms|snews|soap\\.udp|soldat|ssh|steam|SubEthaEdit|svn\\+ssh|svn|t120|tann|tcp|telephone|txmt|uddi|unreal|ut2004|uuid|videotex|view-source|wcap|webcal|whodp|whois\\+\\+|whois|wpn|wtai|xeerkat|xfire|ymsgr)";
    this.SCHEME = "(" + this.OFFICIAL_SCHEME + "|" + this.UNOFFICIAL_SCHEME + "):";
    this.IP_LITERAL = "(\\[((([a-f\\d]{1,4}:){6}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(::([a-f\\d]{1,4}:){5}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(([a-f\\d]{1,4})?::([a-f\\d]{1,4}:){4}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|((([a-f\\d]{1,4}:)?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){3}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,2})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){2}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,3})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,4})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,5})?[a-f\\d]{1,4})?::[a-f\\d]{1,4})|(((([a-f\\d]{1,4}:){1,6})?[a-f\\d]{1,4})?::))\\])";
    this.IPV4ADDRESS = "((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5]))";
    this.IP = "(" + this.IPV4ADDRESS + "|" + this.IP_LITERAL + ")";
    this.AUTHORITY = "([a-z\\d]([\\w-.~!$&*+,=:]|%[a-f\\d]{2})*@)?";
    this.REG_NAME = "([a-z\\d]([\\w-~!$&*+,=@]|%[a-f\\d]{2})+\\.)+";
    this.SIMPLE = "([a-z\\d]([\\w-~!$&'()*+,;=]|%[a-f\\d]{2})+)";
    this.TLD = "(ac|ad|aero|ae|af|ag|ai|al|am|an|ao|aq|arpa|ar|asia|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|biz|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|cat|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|coop|com|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|info|int|in|io|iq|ir|is|it|je|jm|jobs|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mil|mk|ml|mm|mn|mobi|mo|mp|mq|mr|ms|mt|museum|mu|mv|mw|mx|my|mz|name|na|nc|net|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pro|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tel|tf|tg|th|tj|tk|tl|tm|tn|to|tp|travel|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|xn--0zwm56d|xn--11b5bs3a9aj6g|xn--80akhbyknj4f|xn--9t4b11yi5a|xn--deba0ad|xn--g6w251d|xn--hgbk6aj7f53bba|xn--hlcj6aya9esc7a|xn--jxalpdlp|xn--kgbechtv|xn--zckzah|ye|yt|yu|za|zm|zw)";
    this.PORT = "(:\\d+)?";
    this.HIER_PART = "(((\\/\\/)?((([\\w-.~!$&'()*+,;=:]|%[a-f\\d]{2})*@)?(" + this.IP + "|([\\w-.~!$&'()*+,;=]|%[a-f\\d]{2})*)" + this.PORT + "))([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)";
    this.PATH = "([;/]([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)?";
    this.QUERY_FRAGMENT = "([&?]([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?(#([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?";

    this.URI1 = "(" + this.SCHEME + this.HIER_PART + this.QUERY_FRAGMENT + ")";
    this.URI2 = "(" + this.AUTHORITY + "(" + this.IP + "|(" + this.REG_NAME + this.TLD + "\\b))" + this.PORT + this.PATH + this.QUERY_FRAGMENT + ")";

    this.uriRegExp = new RegExp("^(" + this.URI1 + "|" + this.URI2 + ")$", "i");
    this.simpleRegExp = new RegExp("^" + this.SIMPLE + "\\b" + this.PORT + "$", "i");

    this.doReload = true;

    this.updateTab = function()
    {
        if (!this.tabbox) return;

        switch (this.tabbox.selectedIndex)
        {
            case 0: this.tab = "elementWhitelist"; break;
            case 1: this.tab = "elementBlacklist"; break;
            case 2: this.tab = "contentWhitelist"; break;
            case 3: this.tab = "contentBlacklist"; break;
            case 4: this.tab = "attributes"; break;
            case 5: this.tab = "script"; break;
            case 6: this.tab = "extension"; break;
        }
    }

    this.setUserSelect = function(value)
    {
        this.userSelect = value != false;
    }

    this.setValue = function(value)
    {
        if (this.listboxPages.selectedIndex < 0) return;

        switch (this.tab)
        {
            case "script":
                this.tabs[this.tab].list.set(null, null, value);
                this.refreshTab(this.tab);
                break;

            case "extension":
                this.tabs[this.tab].object.setValue(value);
                break;
        }
    }

    this.doCut = function()
    {
        if (this.listboxPages.selectedIndex < 0) return;

        this.page = new YaripPage();
        var list = null;
        switch (this.tab)
        {
            case "elementWhitelist":
                list = this.page.elementWhitelist;
                break;
            case "elementBlacklist":
                list = this.page.elementBlacklist;
                break;
            case "contentWhitelist":
                list = this.page.contentWhitelist;
                break;
            case "contentBlacklist":
                list = this.page.contentBlacklist;
                break;
            case "attributes":
                list = this.page.attributes;
                break;
            case "extension":
                list = this.page.extension;
                break;
//            case "script":
//                list = this.page.script;
//                break;
            default:
                return;
        }

        var keys = {}
        var rangeCount = this.tabs[this.tab].tree.view.selection.getRangeCount();
        for (var i = 0; i < rangeCount; i++)
        {
            var start = {};
            var end = {};
            this.tabs[this.tab].tree.view.selection.getRangeAt(i, start, end);
            for (var j = start.value; j <= end.value; j++) {
                var k = this.tabs[this.tab].list.get(j, -1);
                keys[k] = true;
                list.add(this.tabs[this.tab].list.obj[k].clone());
            }
        }
        for (var k in keys) this.tabs[this.tab].list.remove(k);
        this.refreshTab(this.tab, true);
        yarip.setChangeType(yarip.ESSENTIAL_CHANGE);
        this.setUserSelect();
    }

    this.doCopy = function()
    {
        if (this.listboxPages.selectedIndex < 0) return;

        this.page = new YaripPage();
        var list = null;
        switch (this.tab)
        {
            case "elementWhitelist":
                list = this.page.elementWhitelist;
                break;
            case "elementBlacklist":
                list = this.page.elementBlacklist;
                break;
            case "contentWhitelist":
                list = this.page.contentWhitelist;
                break;
            case "contentBlacklist":
                list = this.page.contentBlacklist;
                break;
            case "attributes":
                list = this.page.attributes;
                break;
            case "extension":
                list = this.page.extension;
                break;
//            case "script":
//                list = this.page.script;
//                break;
            default:
                return;
        }

        var keys = {}
        var rangeCount = this.tabs[this.tab].tree.view.selection.getRangeCount();
        for (var i = 0; i < rangeCount; i++)
        {
            var start = {};
            var end = {};
            this.tabs[this.tab].tree.view.selection.getRangeAt(i, start, end);
            for (var j = start.value; j <= end.value; j++) {
                var k = this.tabs[this.tab].list.get(j, -1);
                list.add(this.tabs[this.tab].list.obj[k].clone());
            }
        }
        this.setUserSelect();
    }

    this.doPaste = function()
    {
        if (!this.page) return;
        if (this.listboxPages.selectedIndex < 0) return;

        var page = this.listboxPages.getItemAtIndex(this.listboxPages.selectedIndex).page;
        page.merge(this.page);
        this.refreshTab(null, true);
        yarip.setChangeType(yarip.ESSENTIAL_CHANGE);
    }

    this.doSelectAll = function()
    {
        if (this.listboxPages.selectedIndex < 0) return;

        this.tabs[this.tab].tree.focus();
        this.tabs[this.tab].tree.view.selection.selectAll();
    }

    this.add = function()
    {
        if (this.listboxPages.selectedIndex < 0) return;

        switch (this.tab)
        {
            case "elementWhitelist":
                var page = this.listboxPages.getItemAtIndex(this.listboxPages.selectedIndex).page;
                var obj = {
                    element: new YaripWLElement("//div[@class='example']"),
                    pageAddress: page.getName()
                }

                window.openDialog("chrome://yarip/content/whitelistdialog.xul", "whitelistdialog", "chrome,modal,resizable", null, obj);
                if (!obj.element) return;

//                page.elementWhitelist.add(new YaripWLElement("//div[@class='example']"));
                page.elementWhitelist.add(obj.element);
                break;
            case "elementBlacklist":
                var page = this.listboxPages.getItemAtIndex(this.listboxPages.selectedIndex).page;
                var obj = {
                    element: new YaripBLElement("//div[@class='example']"),
                    pageAddress: page.getName()
                }

                window.openDialog("chrome://yarip/content/blacklistdialog.xul", "blacklistdialog", "chrome,modal,resizable", null, obj);
                if (!obj.element) return;

//                page.elementBlacklist.add(new YaripBLElement("//div[@class='example']"));
                page.elementBlacklist.add(obj.element);
                break;
            case "contentWhitelist":
                var page = this.listboxPages.getItemAtIndex(this.listboxPages.selectedIndex).page;
                var obj = {
                    content: new YaripWLContent("^http://[\\w.-]*\\bexample\\.net\\b"),
                    pageAddress: page.getName()
                }

                window.openDialog("chrome://yarip/content/whitelistcontentdialog.xul", "whitelistcontentdialog", "chrome,modal,resizable", obj);
                if (!obj.content) return;

//                page.contentWhitelist.add(new YaripWLContent("^http://[\\w.-]*\\bexample\\.net\\b"));
                page.contentWhitelist.add(obj.content);
                break;
            case "contentBlacklist":
                var page = this.listboxPages.getItemAtIndex(this.listboxPages.selectedIndex).page;
                var obj = {
                    content: new YaripBLContent("^http://[\\w.-]*\\bexample\\.net\\b"),
                    pageAddress: page.getName()
                }

                window.openDialog("chrome://yarip/content/whitelistcontentdialog.xul", "whitelistcontentdialog", "chrome,modal,resizable", obj);
                if (!obj.content) return;
//                page.contentBlacklist.add(new YaripBLContent("^http://[\\w.-]*\\bexample\\.net\\b"));
                page.contentBlacklist.add(obj.content);
                break;
            case "attributes":
                var page = this.listboxPages.getItemAtIndex(this.listboxPages.selectedIndex).page;
                var obj = {
                    element: new YaripAttribute("//div[@class='example']", "style", "width:auto;"),
                    attrName: "style",
                    attrValue: "width:auto;",
                    pageAddress: page.getName()
                }

                window.openDialog("chrome://yarip/content/styledialog.xul", "styledialog", "chrome,modal,resizable", null, obj);
                if (!obj.element) return;
                if (!obj.attrName || obj.attrName == "") return;

                obj.element.setName(obj.attrName);
                obj.element.setValue(obj.attrValue);

//                page.attributes.add(new YaripAttribute("//div[@class='example']", "style", "width:auto;"));
                page.attributes.add(obj.element);
                break;
        }

        this.refreshTab(this.tab, true);
    }

    this.remove = function()
    {
        if (this.tabs[this.tab].tree.currentIndex < 0) return;

        switch (this.tab)
        {
            case "elementWhitelist":
            case "elementBlacklist":
            case "attributes":
            case "extension":
            case "contentWhitelist":
            case "contentBlacklist":
                var keys = {}
                var rangeCount = this.tabs[this.tab].tree.view.selection.getRangeCount();
                for (var i = 0; i < rangeCount; i++)
                {
                    var start = {};
                    var end = {};
                    this.tabs[this.tab].tree.view.selection.getRangeAt(i, start, end);
//                    for (var j = start.value; j <= end.value; j++) keys[this.tabs[this.tab].list.get(j, 0)] = true;
                    for (var j = start.value; j <= end.value; j++) keys[this.tabs[this.tab].list.get(j, -1)] = true;
                }
                for (var k in keys) this.tabs[this.tab].list.remove(k);
                this.refreshTab(this.tab, true);
                yarip.setChangeType(yarip.ESSENTIAL_CHANGE);
                break;
        }
    }

    this.removeAll = function()
    {
        if (this.listboxPages.selectedIndex < 0) return;
        if (!this.tabs[this.tab].list || this.tabs[this.tab].list.length == 0) return;

        this.tabs[this.tab].list.reset();
        this.refreshTab(this.tab, true);
        this.refreshExtMenulist();
        yarip.setChangeType(yarip.ESSENTIAL_CHANGE);
    }

    this.setExclusive = function(exclusive)
    {
        if (this.listboxPages.selectedIndex < 0) return;

        switch (this.tab)
        {
            case "elementWhitelist":
            case "contentWhitelist":
                this.tabs[this.tab].list.setExclusive(exclusive);
                break;

            case "elementBlacklist":
            case "attributes":
            case "extension":
            case "contentBlacklist":
                break;
        }
    }

    this.addExtPage = function()
    {
        if (this.listboxPages.selectedIndex < 0) return;
        if (!this.tabs[this.tab].object) return;

        var id = this.tabs[this.tab].object.getValue();
        if (id != "" && id != this.listboxPages.getItemAtIndex(this.listboxPages.selectedIndex).page.getId())
        {
            var o = this.tabs[this.tab].object.clone();
            this.tabs[this.tab].list.add(o);
            this.tabs[this.tab].list.sort();
            this.refreshTab(this.tab, true);
            yarip.setChangeType(yarip.ESSENTIAL_CHANGE);
        }
    }

    this.removeExtPage = function()
    {
        if (this.tabs[this.tab].tree.currentIndex < 0) return;

        var keys = {}
        var rangeCount = this.tabs[this.tab].tree.view.selection.getRangeCount();
        for (var i = 0; i < rangeCount; i++)
        {
            var start = {};
            var end = {};
            this.tabs[this.tab].tree.view.selection.getRangeAt(i, start, end);
            for (var j = start.value; j <= end.value; j++) keys[yarip.map.obj[this.tabs[this.tab].list.get(j, 0)].getId()] = true;
        }
        for (var k in keys) this.tabs[this.tab].list.remove(k);
        this.refreshTab(this.tab, true);
        this.refreshExtMenulist();
        yarip.setChangeType(yarip.ESSENTIAL_CHANGE);
    }

    this.newPage = function()
    {
        this.listboxPages.selectedIndex = -1;
        this.renamePage(new YaripPage(yarip.getId(), "www.example.net"));
    }

    this.copyPage = function()
    {
        if (this.listboxPages.selectedIndex < 0) return;

        var page = this.listboxPages.getItemAtIndex(this.listboxPages.selectedIndex).page.clone(true);
        this.renamePage(page);
    }

    this.checkPage = function(name)
    {
        if (!name) return false;

        try { if (!this.uriRegExp.test(name) && !this.simpleRegExp.test(name)) throw new YaripException(this.stringbundle.getString("ERR_INVALID_PAGE")); }
        catch (e)
        {
            alert(e.message);
            return false;
        }

        return true;
    }

    this.selectTab = function(listboxItem)
    {
        if (!listboxItem) return;

        if (listboxItem.page.elementWhitelist.length == 0)
        {
            if (listboxItem.page.elementBlacklist.length == 0)
            {
                if (listboxItem.page.contentWhitelist.length == 0)
                {
                    if (listboxItem.page.contentBlacklist.length == 0)
                    {
                        if (listboxItem.page.attributes.length == 0)
                        {
                            if (listboxItem.page.script.length == 0)
                            {
                                if (listboxItem.page.extension.length == 0) this.tabbox.selectedIndex = 0;
                                else this.tabbox.selectedIndex = 6;
                            }
                            else
                            {
                                this.tabbox.selectedIndex = 5;
                            }
                        }
                        else
                        {
                            this.tabbox.selectedIndex = 4;
                        }
                    }
                    else
                    {
                        this.tabbox.selectedIndex = 3;
                    }
                }
                else
                {
                    this.tabbox.selectedIndex = 2;
                }
            }
            else
            {
                this.tabbox.selectedIndex = 1;
            }
        }
        else
        {
            this.tabbox.selectedIndex = 0;
        }
    }

    this.selectListboxItem = function(pageName)
    {
        if (!pageName)
        {
            this.listboxPages.selectedIndex = -1;
            this.listboxPages.ensureIndexIsVisible(0);
            return null;
        }

        for (var i = 0; i < this.listboxPages.getRowCount(); i++)
        {
            var item = this.listboxPages.getItemAtIndex(i);
            if (item.page.getName() == pageName)
            {
                this.listboxPages.selectedIndex = i;
                this.listboxPages.ensureIndexIsVisible(i);
                return item;
            }
        }

        return null;
    }

    this.renamePage = function(page)
    {
        var oldName = null;
        var selectedIndex = -1;
        if (!page)
        {
            selectedIndex = this.listboxPages.selectedIndex;
            if (selectedIndex < 0) return false;
            page = this.listboxPages.getItemAtIndex(selectedIndex).page;
            oldName = page.getName();
        }
        var pageName = prompt(this.stringbundle.getString("enterNameOfPage"), page.getName());
        if (!pageName || pageName == "" || !this.checkPage(pageName)) return false;

        if (oldName) {
            yarip.map.removeByName(oldName);
            this.listboxPages.removeItemAt(selectedIndex);
        }
        page.setName(pageName);
        yarip.map.add(page);
        yarip.map.sort();
        yarip.setChangeType(yarip.ESSENTIAL_CHANGE);

        var i = 0;
        var tmpPage = new YaripPage("0", pageName);
        while (i < this.listboxPages.getRowCount() && yarip.map.sortByPage(tmpPage, this.listboxPages.getItemAtIndex(i).page) > 0) i++;

        var listitem = this.listitemDummy.cloneNode(true);
        listitem.setAttribute("label", pageName);
        listitem.page = page;

        if (i < this.listboxPages.getRowCount())
        {
            var sortResult = yarip.map.sortByPage(tmpPage, this.listboxPages.getItemAtIndex(i).page);
            if (sortResult != 0)
            {
                if (sortResult < 0)
                {
                    var oldListitem = this.listboxPages.insertItemAt(i, pageName, "");
                    this.listboxPages.replaceChild(listitem, oldListitem); // https://bugzilla.mozilla.org/show_bug.cgi?id=437394
                }
                else this.listboxPages.appendChild(listitem);
            }
        }
        else this.listboxPages.appendChild(listitem);

        this.listboxPages.selectedIndex = i;
        this.listboxPages.ensureIndexIsVisible(i);
        this.selectTab(listitem);
        this.refreshExtMenulist(true);

        return true;
    }

    this.removePages = function()
    {
        if (this.listboxPages.selectedIndex < 0) return;

        this.listboxPages.removeEventListener("select", this, false);
        var item = this.listboxPages.getSelectedItem(0);
        while (item)
        {
            var index = this.listboxPages.getIndexOfItem(item);
//            yarip.map.removeByName(this.listboxPages.removeItemAt(index).page.getName());
            yarip.map.remove(this.listboxPages.removeItemAt(index).page);
            item = this.listboxPages.getSelectedItem(0);
        }
        this.listboxPages.addEventListener("select", this, false);
        this.refreshPages(true, true);
        yarip.setChangeType(yarip.ESSENTIAL_CHANGE);
    }

    this.refreshPages = function(load, dontReloadPages)
    {
        if (load && !dontReloadPages)
        {
            this.listboxPages.removeEventListener("select", this, false);
            var rowCount = 0;
            while ((rowCount = this.listboxPages.getRowCount()) > 0 && this.listboxPages.removeItemAt(rowCount - 1));
            this.listboxPages.addEventListener("select", this, false);

            var map = yarip.map.obj;
            for (var p in map)
            {
                var page = map[p];
                if (!page) continue;
                var listitem = this.listitemDummy.cloneNode(true);
                listitem.setAttribute("label", p);
                listitem.page = page;
                this.listboxPages.appendChild(listitem);
            }
        }

        var page = null;
        var listitem = null;
        if (load || this.listboxPages.selectedIndex < 0) page = new YaripPage("0");
        else
        {
            listitem = this.listboxPages.getSelectedItem(0);
            page = listitem.page;
            page.setTemporary(false);
        }

        this.dialogheaderPage.setAttribute("title", page.getName());
        this.tabs["elementWhitelist"].list = page.elementWhitelist;
        this.tabs["elementBlacklist"].list = page.elementBlacklist;
        this.tabs["contentWhitelist"].list = page.contentWhitelist;
        this.tabs["contentBlacklist"].list = page.contentBlacklist;
        this.tabs["attributes"].list = page.attributes;
        this.tabs["script"].list = page.script;
        this.tabs["extension"].list = page.extension;

        this.tabs["elementWhitelist"].tab.setAttribute("label", this.stringbundle.getFormattedString("elementWhitelist-tab", [this.tabs["elementWhitelist"].list.length]));
        this.tabs["elementBlacklist"].tab.setAttribute("label", this.stringbundle.getFormattedString("elementBlacklist-tab", [this.tabs["elementBlacklist"].list.length]));
        this.tabs["contentWhitelist"].tab.setAttribute("label", this.stringbundle.getFormattedString("contentWhitelist-tab", [this.tabs["contentWhitelist"].list.length]));
        this.tabs["contentBlacklist"].tab.setAttribute("label", this.stringbundle.getFormattedString("contentBlacklist-tab", [this.tabs["contentBlacklist"].list.length]));
        this.tabs["attributes"].tab.setAttribute("label", this.stringbundle.getFormattedString("attributes-tab", [this.tabs["attributes"].list.length]));
        this.tabs["script"].tab.setAttribute("label", this.stringbundle.getFormattedString("script-tab", [this.tabs["script"].list.length]));
        this.tabs["extension"].tab.setAttribute("label", this.stringbundle.getFormattedString("extension-tab", [this.tabs["extension"].list.length]));

        if (load) this.tabs["extension"].object = new YaripItem();

        if (this.listboxPages.selectedIndex >= 0)
        {
            for (var k in page.extension.obj)
            {
                if (!yarip.map.objId[k]) {
                    page.extension.remove(k);
                    yarip.setChangeType(yarip.ESSENTIAL_CHANGE);
                }
            }
        }

        this.refreshTab(null, true);
        if (!load && !this.userSelect && this.listboxPages.selectedIndex >= 0) this.selectTab(listitem);
        this.refreshExtMenulist(load);
    }

    this.importFiles = function()
    {
        var nsIFilePicker = Components.interfaces.nsIFilePicker;
        var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        fp.init(window, this.stringbundle.getString("importPages"), nsIFilePicker.modeOpenMultiple);
        fp.appendFilters(nsIFilePicker.filterXML);
        var res = fp.show();
        if (res != nsIFilePicker.returnOK) return;
        var files = fp.files;
        var pageName = null;
        var pName = null;
        while (files.hasMoreElements())
        {
            pName = yarip.load(files.getNext(), true);
            if (pName) pageName = pName;
        }
        if (pageName)
        {
            yarip.map.sort();
            yarip.setChangeType(yarip.ESSENTIAL_CHANGE);
            if (!pageName && this.listboxPages.selectedIndex > -1) pageName = this.listboxPages.getSelectedItem(0).page.getName();
            this.refreshPages(true);
            if (pageName) this.selectTab(this.selectListboxItem(pageName));
        }
    }

    this.getDateString = function()
    {
        var now = new Date();
        var year = now.getFullYear();
        var month = now.getMonth() + 1
        var day = now.getDate();
        return year + "-" + (month < 10 ? "0" : "") + month + "-" + (day < 10 ? "0" : "") + day;
    }

    this.exportPages = function()
    {
        if (this.listboxPages.selectedIndex < 0) return;

        var aAddress = {}
        var item = this.listboxPages.getSelectedItem(0);
        var page = null;
        var index = 0;
        while (item)
        {
            page = item.page;
            aAddress[page.getName()] = true;
            item = this.listboxPages.getSelectedItem(++index);
        }
        var map = new YaripMap();
        yarip.getExtensionAddressArray(aAddress, true);
        for (var p in aAddress) map.add(yarip.map.obj[p].clone());
        if (index == 0) return;

        var dateStr = this.getDateString();
        var nsIFilePicker = Components.interfaces.nsIFilePicker;
        var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        fp.init(window, this.stringbundle.getString("exportPages"), nsIFilePicker.modeSave);
        fp.appendFilters(nsIFilePicker.filterXML);
        if (index == 1) fp.defaultString = dateStr + "_" + page.getName().replace(/\/+$/, "").replace(/\//g, "_") + ".xml";
        else fp.defaultString = fp.defaultString = dateStr + "_yarip-pages.xml";
        var res = fp.show();
        if (res == nsIFilePicker.returnOK || res == nsIFilePicker.returnReplace)
        {
            map.sort(false, true); // don't reduce but purge
            var data = map.generateXml(true);
            yarip.saveToFile(data, fp.file);
        }
    }

    this.exportAll = function()
    {
        var dateStr = this.getDateString();
        var nsIFilePicker = Components.interfaces.nsIFilePicker;
        var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        fp.init(window, this.stringbundle.getString("exportPages"), nsIFilePicker.modeSave);
        fp.appendFilters(nsIFilePicker.filterXML);
        fp.defaultString = dateStr + "_yarip.xml";
        var res = fp.show();
        if (res == nsIFilePicker.returnOK || res == nsIFilePicker.returnReplace)
        {
            var map = yarip.map.clone();

            map.sort(false, true); // don't reduce but purge
            var data = map.generateXml(true);
            yarip.saveToFile(data, fp.file);
        }
    }

    this.refreshTab = function(tab, load)
    {
        if (!tab)
        {
            this.refreshTab("elementWhitelist", load);
            this.refreshTab("elementBlacklist", load);
            this.refreshTab("contentWhitelist", load);
            this.refreshTab("contentBlacklist", load);
            this.refreshTab("attributes", load);
            this.refreshTab("script", load);
            this.refreshTab("extension", load);
            return;
        }

        switch (tab)
        {
            case "elementWhitelist":
            case "elementBlacklist":
            case "attributes":
                if (load) {
                    this.tabs[tab].tree.view = new YaripTreeView(this.tabs[tab].list, this);
                }
                if (load || this.tabs[tab].tree.currentIndex < 0) {
                    switch (tab) {
                        case "elementWhitelist": this.tabs[tab].object = new YaripWLElement(); break;
                        case "elementBlacklist": this.tabs[tab].object = new YaripBLElement(); break;
                        case "attributes": this.tabs[tab].object = new YaripAttribute(); break;
                    }
                } else {
                    var k = this.tabs[tab].list.get(this.tabs[tab].tree.currentIndex, 0);
                    this.tabs[tab].object = this.tabs[tab].list.obj[k].clone();
                }

                this.tabs[tab].tab.setAttribute("label", this.stringbundle.getFormattedString(tab + "-tab", [this.tabs[tab].list.length]));
                break;

            case "contentWhitelist":
            case "contentBlacklist":
                if (load) {
                    this.tabs[tab].tree.view = new YaripTreeView(this.tabs[tab].list, this);
                }
                if (load || this.tabs[tab].tree.currentIndex < 0) {
                    switch (tab) {
                        case "contentWhitelist": this.tabs[tab].object = new YaripWLContent(); break;
                        case "contentBlacklist": this.tabs[tab].object = new YaripBLContent(); break;
                    }
                } else {
                    var k = this.tabs[tab].list.get(this.tabs[tab].tree.currentIndex, 0);
                    this.tabs[tab].object = this.tabs[tab].list.obj[k].clone();
                }

                this.tabs[tab].tab.setAttribute("label", this.stringbundle.getFormattedString(tab + "-tab", [this.tabs[tab].list.length]));
                if (tab == "contentWhitelist") {
                    this.tabs[tab].exclMenulist.selectedIndex = this.tabs[tab].list.getExclusive() ? 0 : 1;
                }
                break;

            case "script":
                this.tabs[tab].tab.setAttribute("label", this.stringbundle.getFormattedString(tab + "-tab", [this.tabs[tab].list.length]));
                this.tabs[tab].textbox.value = this.tabs[tab].list.get();
                break;

            case "extension":
                if (load) {
                    this.tabs[tab].tree.view = new YaripTreeView(this.tabs[tab].list, this);
                }

                this.tabs[tab].tab.setAttribute("label", this.stringbundle.getFormattedString(tab + "-tab", [this.tabs[tab].list.length]));
                break;
        }
    }

    this.reloadPage = function(pageName, refresh, select)
    {
        if (refresh) this.refreshPages(true);

//        var page = yarip.map.obj[pageName];
        var page = yarip.map.get(pageName);
        if (!page) return;

        var i = 0;
        while (i < this.listboxPages.getRowCount() && yarip.map.sortByPage(page, this.listboxPages.getItemAtIndex(i).page) > 0) i++;

        var listitem = null;
        if (i < this.listboxPages.getRowCount())
        {
            switch (yarip.map.sortByPage(page, this.listboxPages.getItemAtIndex(i).page))
            {
                case -1:
                    listitem = this.listitemDummy.cloneNode(true);
                    listitem.setAttribute("label", pageName);
                    listitem.page = page;
                    this.listboxPages.replaceChild(listitem, this.listboxPages.insertItemAt(i, pageName, "")); // https://bugzilla.mozilla.org/show_bug.cgi?id=437394
                    break;

                case 0:
                    this.refreshPages();
                    break;

                case 1:
                    listitem = this.listitemDummy.cloneNode(true);
                    listitem.setAttribute("label", pageName);
                    listitem.page = page;
                    this.listboxPages.appendChild(listitem);
                    break;
            }
        }
        else
        {
            listitem = this.listitemDummy.cloneNode(true);
            listitem.setAttribute("label", pageName);
            listitem.page = page;
            this.listboxPages.appendChild(listitem);
        }

        this.refreshExtMenulist(true);

        if (select) this.selectListboxItem(pageName);
    }

    this.handleEvent = function(event)
    {
        if (!event) return;

        switch(event.target.id)
        {
            case "listbox-pages":
                this.refreshPages();
                break;

            case "elementWhitelist-tree":
            case "elementBlacklist-tree":
            case "contentWhitelist-tree":
            case "contentBlacklist-tree":
            case "attributes-tree":
                this.refreshTab(this.tab);
                break;

            case "keypress":
                switch (event.keyCode)
                {
                    case 27: // escape
                        event.stopPropagation();
                        break;
                }
                break;
        }
    }

    this.initTab = function(tab)
    {
        if (!tab) return;

        switch (tab)
        {
            case "elementWhitelist":
                this.tabs[tab] = {};
                this.tabs[tab].tab = document.getElementById(tab + "-tab");
                this.tabs[tab].tree = document.getElementById(tab + "-tree");
                this.tabs[tab].tree.addEventListener("select", this, false);
                break;

            case "elementBlacklist":
                this.tabs[tab] = {};
                this.tabs[tab].tab = document.getElementById(tab + "-tab");
                this.tabs[tab].tree = document.getElementById(tab + "-tree");
                this.tabs[tab].tree.addEventListener("select", this, false);
                break;

            case "contentWhitelist":
                this.tabs[tab] = {};
                this.tabs[tab].tab = document.getElementById(tab + "-tab");
                this.tabs[tab].tree = document.getElementById(tab + "-tree");
                this.tabs[tab].tree.addEventListener("select", this, false);
                this.tabs[tab].exclMenulist = document.getElementById(tab + "-exclusive");
                break;

            case "contentBlacklist":
                this.tabs[tab] = {};
                this.tabs[tab].tab = document.getElementById(tab + "-tab");
                this.tabs[tab].tree = document.getElementById(tab + "-tree");
                this.tabs[tab].tree.addEventListener("select", this, false);
                break;

            case "attributes":
                this.tabs[tab] = {};
                this.tabs[tab].tab = document.getElementById(tab + "-tab");
                this.tabs[tab].tree = document.getElementById(tab + "-tree");
                this.tabs[tab].tree.addEventListener("select", this, false);
                break;

            case "script":
                this.tabs[tab] = {};
                this.tabs[tab].tab = document.getElementById(tab + "-tab");
                this.tabs[tab].textbox = document.getElementById(tab + "-textbox");
                break;

            case "extension":
                this.tabs[tab] = {};
                this.tabs[tab].tab = document.getElementById(tab + "-tab");
                this.tabs[tab].menulist = document.getElementById(tab + "-menulist");
                this.tabs[tab].tree = document.getElementById(tab + "-tree");
                break;
        }
    }

    this.refreshExtMenulist = function(load)
    {
        if (load)
        {
            var menupopup = document.createElement("menupopup");
            var pages = yarip.map.obj;
            for (var p in pages)
            {
                var page = pages[p];
                if (!page) continue;

                var menuitem = document.createElement("menuitem");
                menuitem.setAttribute("label", p);
                menuitem.setAttribute("value", page.getId());
                menupopup.appendChild(menuitem);
            }
            this.tabs["extension"].menulist.replaceChild(menupopup, this.tabs["extension"].menulist.firstChild);
        }

        if (this.tabs["extension"].menulist.firstChild.childNodes.length > 0)
        {
            if (this.tabs["extension"].menulist.selectedIndex < 0) this.tabs["extension"].menulist.selectedIndex = 0;
            this.tabs["extension"].object.setValue(this.tabs["extension"].menulist.selectedItem.getAttribute("value"));
        }
    }

    this.load = function()
    {
        var pageName = null;
        if ("arguments" in window && window.arguments.length > 0) pageName = window.arguments[0];

        this.stringbundle = document.getElementById("page-dialog-stringbundle");
        this.listboxPages = document.getElementById("listbox-pages");
        this.listitemDummy = document.getElementById("listitem-dummy");
        this.dialogheaderPage = document.getElementById("dialogheader-page");
        this.tabbox = document.getElementById("tabbox");

        this.tab = "elementWhitelist";
        this.tabs = {};
        this.initTab("elementWhitelist");
        this.initTab("elementBlacklist");
        this.initTab("contentWhitelist");
        this.initTab("contentBlacklist");
        this.initTab("attributes");
        this.initTab("script");
        this.initTab("extension");

        this.refreshPages(true);

        if (pageName) this.selectTab(this.selectListboxItem(pageName));
        yarip.pageDialog = this;
    }

    this.unload = function()
    {
        yarip.pageDialog = null;

        this.listboxPages.removeEventListener("select", this, false);
        this.tabs["elementWhitelist"].tree.removeEventListener("select", this, false);
        this.tabs["elementBlacklist"].tree.removeEventListener("select", this, false);
        this.tabs["contentWhitelist"].tree.removeEventListener("select", this, false);
        this.tabs["contentBlacklist"].tree.removeEventListener("select", this, false);
        this.tabs["attributes"].tree.removeEventListener("select", this, false);

        yarip.save();
        yarip.toggleStyle();
    }

    this.onApply = function()
    {
        this.doReload = false;
        yarip.setChangeType(yarip.ESSENTIAL_CHANGE);
        yarip.save();
        yarip.toggleStyle();
        this.doReload = true;
    }
}

function YaripTreeView(list, pd)
{
    this.list = list;
    this.pd = pd;
    this.rowCount = this.list.length;
    this.cycleHeader = function(col) {}
    this.getCellProperties = function(row, col, props) {}
    this.getCellText = function(row, col) { return this.list.get(row, col.index); }
    this.getCellValue = function(row, col) { return this.list.get(row, col.index); }
    this.getColumnProperties = function(colid, col, props) {}
    this.getImageSrc = function(row, col) { return null; }
    this.getLevel = function(row) { return 0; }
    this.getRowProperties = function(row, props) {}
    this.isContainer = function(row) { return false; }
    this.isEditable = function(row, col) { return col.element.getAttribute("editable"); }
    this.isSeparator = function(row) { return false; }
    this.isSorted = function(row) { return false; }
    this.setCellText = function(row, col, value) { this.list.set(row, col.index, value); pd.refreshTab(null, true); }
    this.setCellValue = function(row, col, value) { this.list.set(row, col.index, value); pd.refreshTab(null, true); }
    this.setTree = function(treebox) { this.treebox = treebox; }
}
